'''
title = Simple Object Targetting
by: fabius astelix @2009-04
revisers:
summary: Move the mouse to point an object
'''
###if not '_P3DPOD_' in globals():
  ###from pandac.PandaModules import loadPrcFileData
  ###loadPrcFileData("", '''#
###model-path $MAIN_DIR/data/models/
###model-path $MAIN_DIR/data/fonts/
###model-path $MAIN_DIR/data/shaders/
###sound-path $MAIN_DIR/data/sounds/
###texture-path $MAIN_DIR/data/textures/
###particle-path $MAIN_DIR/data/particles/
  ###''')
  #### use it just if needed to use shared data and modules
  ###import os, sys
  ##### for shared modules
  ###shareddir=os.path.abspath(os.path.normpath("../../../../shared"))
  ###sys.path.append(os.path.join(shareddir, 'scripts'))
  ##### for shared data
  ###loadPrcFileData("", '''#
###model-path %(shareddir)s/data/models/
###model-path %(shareddir)s/data/fonts/
###model-path %(shareddir)s/data/shaders/
###sound-path %(shareddir)s/data/sounds/
###texture-path %(shareddir)s/data/textures/
###particle-path %(shareddir)s/data/particles/
  ###''' % ({'shareddir': shareddir}))
#
from pandac.PandaModules import *
from direct.showbase.DirectObject import DirectObject
from direct.task import Task
import direct.directbase.DirectStart
import random
from p3dutils import track_pos

class World(DirectObject):
  def __init__(self):
    # in pod
    axis=loader.loadModel('zup-axis')
    axis.reparentTo(render)
    axis.setPos(0,0,0)
    axis.setScale(.5)
    # raggruppa gli oggetti da traversare (TO)
    # in metoto override
    self.targetGroupNP=render.attachNewNode("targetGroup")
    #for i in range(10):
      #ball = loader.loadModel("smiley")
      #ball.reparentTo(self.targetGroupNP)
      #ball.setTag('target', str(i))
      #ball.setPos(random.randint(-4,4),random.randint(0,10),random.randint(-4,4))
      #ball.setScale(.4)
      #ball.setCollideMask(BitMask32.bit(1))
    for i in range(1):
      ball = loader.loadModel("planeglobe.egg.pz")
      ball.reparentTo(self.targetGroupNP)
      ball.setTag('target', str(i))
      ball.setPos(0,0,0)
      ball.setCollideMask(BitMask32.bit(1))
    # pod
    self.centercam()
    base.camLens.setNearFar(0.1, 1000)
    # luci! (pod)
    dlight = DirectionalLight('dlight')
    dlight.setColor(VBase4(0.9, 0.9, 0.9, 1))
    dlnp = render.attachNewNode(dlight)
    dlnp.setHpr(0, -60, 0)
    render.setLight(dlnp)
    # make the picker ray (FROM)
    self.mkpicker()
    pointercolor=(1, 0, 0, 1 )
    self.pointer=self.mktxcard(texture='arrow.png', color=pointercolor)
    markercolor=(0, 1, 0, 1 )
    self.marker=self.mktxcard(texture='arrow.png', color=markercolor)
    #
    self.mouseTask=taskMgr.add(self.mouseTask, 'mouseTask')
    self.tp_pointer=track_pos(subject=self.pointer, fgcolor=pointercolor)
    self.tp_marker=track_pos(
      subject=self.marker, textpos=(-1,-.90), fgcolor=markercolor
    )
    #
    self.accept("mouse1-up", self.dropmarker)
    # pod
    self.accept("c", self.centercam)
  #----------------------------------------------------
  # pod
  def centercam(self):
    base.mouseInterfaceNode.setPos(0, 30, -4.2)
  #----------------------------------------------------
  #
  def mkpicker(self):
    self.picker = CollisionTraverser()            #Make a traverser
    self.pq     = CollisionHandlerQueue()         #Make a handler
    #Make a collision node for our picker ray
    self.pickerNode = CollisionNode('mouseRay')
    #Attach that node to the camera since the ray will need to be positioned relative to it
    self.pickerNP = camera.attachNewNode(self.pickerNode)
    #Everything to be picked will use bit 1. This way if we were doing other collision we could seperate it
    self.pickerNode.setFromCollideMask(BitMask32.bit(1))
    self.pickerRay = CollisionRay()
    self.pickerNode.addSolid(self.pickerRay)
    #Register the ray as something that can cause collisions
    self.picker.addCollider(self.pickerNP, self.pq)
    self.picker.showCollisions(render)
  #----------------------------------------------------
  #
  def mouseTask(self, task):
    '''per seguire real time gli spostamenti del mouse
    '''
    if base.mouseWatcherNode.hasMouse():
      mpos = base.mouseWatcherNode.getMouse()
      self.pickerRay.setFromLens(base.camNode, mpos.getX(), mpos.getY())
      self.picker.traverse(self.targetGroupNP)
      if self.pq.getNumEntries() > 0:
        self.pq.sortEntries()
        whos=self.pq.getEntry(0).getIntoNode().getParent(0).getTag('target')
        hitpos=self.pq.getEntry(0).getSurfacePoint(base.render)
        self.showpos(hitpos, whos)
        self.pointer.setPos(hitpos)
    return Task.cont
  #----------------------------------------------------
  #
  def dropmarker(self):
    '''molla giu' il marker sul punto selezionato
    '''
    if base.mouseWatcherNode.hasMouse():
      mpos = base.mouseWatcherNode.getMouse()
      self.pickerRay.setFromLens(base.camNode, mpos.getX(), mpos.getY())
      self.picker.traverse(self.targetGroupNP)
      if self.pq.getNumEntries() > 0:
        self.pq.sortEntries()
        hitpos=self.pq.getEntry(0).getSurfacePoint(base.render)
        self.marker.setPos(hitpos)
    return Task.cont
  #----------------------------------------------------
  #
  def showpos(self, pos, name="", init=False):
    #print "[Hit] '%s'(%r)"%(name, pos)
    pass
  #----------------------------------------------------
  #
  def mktxcard(self,
    name='txcard', texture='frowney.rgb', frame=(-.1, .1, -.1, .1),
    color=None, billboard=True
  ):
    cm = CardMaker(name)
    if color: cm.setColor(*color)
    cm.setHasNormals(False)
    card = render.attachNewNode(cm.generate())
    card.setTransparency(TransparencyAttrib.MAlpha)
    tex = loader.loadTexture(texture)
    card.setTexture(tex)
    card.setEffect(BillboardEffect.makePointEye())
    return card
#----------------------------------------------------------------
pea=World()
if __name__ == "__main__":
  if not '_P3DPOD_' in globals(): run()
